// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package osgi;

public final class HelloPrxHelper extends Ice.ObjectPrxHelperBase implements HelloPrx
{
    public boolean
    sayHello(String who)
    {
        return sayHello(who, null, false);
    }

    public boolean
    sayHello(String who, java.util.Map<String, String> __ctx)
    {
        return sayHello(who, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private boolean
    sayHello(String who, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("sayHello");
                __delBase = __getDelegate();
                _HelloDel __del = (_HelloDel)__delBase;
                return __del.sayHello(who, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (HelloPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::osgi::Hello"))
                {
                    HelloPrxHelper __h = new HelloPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (HelloPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::osgi::Hello", __ctx))
                {
                    HelloPrxHelper __h = new HelloPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::osgi::Hello"))
                {
                    HelloPrxHelper __h = new HelloPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::osgi::Hello", __ctx))
                {
                    HelloPrxHelper __h = new HelloPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static HelloPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            HelloPrxHelper __h = new HelloPrxHelper();
            __h.__copyFrom(__obj);
            __d = __h;
        }
        return __d;
    }

    public static HelloPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        HelloPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            HelloPrxHelper __h = new HelloPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _HelloDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _HelloDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, HelloPrx v)
    {
        __os.writeProxy(v);
    }

    public static HelloPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            HelloPrxHelper result = new HelloPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
